Subject: Re: [PATCH v4] powerpc: Use shared font data

From: "Dr. David Alan Gilbert" <[email-masked]>
Date: Tue, 4 Nov 2025 17:59:01 +0000

* Finn Thain ([email-masked]) wrote:
> 
> On Mon, 3 Nov 2025, Dr. David Alan Gilbert wrote:
> 
> > 
> > > Anyway, I imagine that the problem with your patch was that it relies 
> > > on font data from a different (read only) section, which is 
> > > unavailable for some reason (MMU not fully configured yet?)
> > > 
> > > So I've asked Stan to test a patch that simply removes the relevant 
> > > 'const' keywords. It's not a solution, but might narrow-down the 
> > > search.
> > 
> 
> Stan tested my patch to remove 'const' from the font_desc and font_data 
> structs but it did not help. (There goes that theory.)
> 
> > I wonder if this is a compiler-flag-ism;  I see 
> > arch/powerpc/kernel/Makefile has a pile of special flags, and for 
> > btext.o it has a -fPIC (as well as turning off some other flags). I 
> > wonder if bodging those in lib/fonts/Makefile for 
> > lib/fonts/font_sun8x16.c fixes it? But... this is data - there's no code 
> > is there - are any of those flags relevant for data only?
> > 
> 
> I don't know. But I'm sure Stan would be willing to test a patch for you.

Can one of you point me at the config you're testing with so I can
try some builds with it.

Dave

> > > 
> > > The BootX bootloader doesn't work on New World systems, which is 
> > > probably why we don't see this regression on anything newer than a 
> > > Wallstreet.
> > > 
> > > It's likely that other Old World systems are also affected, if they 
> > > are using BootX. We don't yet know whether the regression also affects 
> > > Old World systems using the iQUIK bootloader instead of BootX.
> > 
> > OK, remember I don't think I've ever tried PPC via MacOS booting, so not 
> > familiar with it.
> > 
> 
> I will try to set up a MacOS guest in QEMU, to see if the hang can be 
> reproduced that way.
> 
-- 
 -----Open up your eyes, open up your mind, open up your code -------   
/ Dr. David Alan Gilbert    |       Running GNU/Linux       | Happy  \ 
\        dave @ treblig.org |                               | In Hex /
 \ _________________________|_____ http://www.treblig.org   |_______/